package com.zd.laboratory.mapper;

import com.zd.laboratory.domain.AlarmLog;
import com.zd.laboratory.domain.LabRiskPlanAbnormalLog;
import com.zd.laboratory.domain.vo.LabRiskPlanAbnormalLogVO;

import java.util.List;
import java.util.Map;

/**
 * 风险异常日志Mapper接口
 *
 * @author liubo
 * @date 2021-09-06
 */
public interface LabRiskPlanAbnormalLogMapper {
    /**
     * 查询风险异常日志
     *
     * @param id 风险异常日志主键
     * @return 风险异常日志
     */
    public LabRiskPlanAbnormalLog selectLabRiskPlanAbnormalLogById(Long id);

    /**
     * 查询风险异常日志列表
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLog> selectLabRiskPlanAbnormalLogList(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 新增风险异常日志
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 结果
     */
    public int insertLabRiskPlanAbnormalLog(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 修改风险异常日志
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 结果
     */
    public int updateLabRiskPlanAbnormalLog(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 删除风险异常日志
     *
     * @param id 风险异常日志主键
     * @return 结果
     */
    public int deleteLabRiskPlanAbnormalLogById(Long id);

    /**
     * 批量删除风险异常日志
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteLabRiskPlanAbnormalLogByIds(Long[] ids);

    /**
     * 风险发生数折线统计图
     */
    List<Map<String, Object>> queryLineChart(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 风险发生占比图
     */
    List<Map<String, Object>> queryHappenChart(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 院系风险统计图
     */
    List<Map<String, Object>> queryStatisticsChartDept(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    int queryPlanCount();

    List<Map<String, Object>> queryRiskTrend(Map<String, Object> params);


    /**
     * 根据预案id和组级id查询风险异常日志列表排序
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLog> selectLabRiskPlanAbnormalLogOrderByList(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);


    /**
     * 小程序查询发生的实验室风险异常日志列表
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLogVO> selectLabRiskPlanAppList(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);

    /**
     * 小程序查询当前发生的实验室风险异常日志统计
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public Map<String,Integer> selectLabRiskPlanAppCount(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);


    /**
     * 小程序查询当前发生的实验室风险异常日志统计
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public Long selectLabRiskPlanAppHappenCount(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);


    /**
     * 小程序查询登录人管理实验室下的预案记录列表
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLogVO> adminSubByRiskPlan(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);


    List<AlarmLog> selectNoBackAlarmLogList(Map<String, Object> params);

}
